If you accept cookies, we’ll use them to improve and customize your experience and enable our partners to show you personalized PayPal ads when you visit other sites. Manage cookies and learn more
Use real-time account updates to reduce declined card payments. Real-time account updater increases payment success by asking the card issuer for updates about the buyer's card, and applying any changes to the current card.
Use this integration guide if you are a merchant and have a direct integration with PayPal.
Only cards that the customer has saved on PayPal's Commerce Platform for future payments are eligible for real-time updates. When triggered, real-time account updater obtains the updated card information to use for the payment. The API response includes data about the card used to complete the payment. For details on how to save a card for future payments, visit Save payment methods.
Examples of payments using a card on file include recurring payments on a subscription for a service or a product, and online or mobile checkout using a previously saved credit or debit card.
Real-time account updater doesn't apply to mobile payments from a digital wallet, such as Apple Pay, Google Pay, and Samsung Pay.
Real-time account updates only occur on subsequent card payments using a card on file. For examples of subsequent payment scenarios, see the Strong Customer Authentication payment indicators page.
Real-time account updater works when issuers agree to share card updates via card networks. PayPal can't provide a card update when the card issuer or cardholder opts out of automatic updates. When a card account doesn't support real-time account updates, request a card update directly from the cardholder.
When a partner or direct merchant has real-time account updater enabled for their account, PayPal checks if the card information is current and eligible for updates.
A merchant has a card on file that was saved for future payments with the customer's consent.
The buyer makes a purchase using the saved card on file, or the merchant uses the card on file for a recurring payment.
PayPal processes the payment as an advanced credit or debit transaction.
Mastercard sends the payment to the card issuer, but the card on file has expired, has been cancelled, or is otherwise not available for payment.
Mastercard notifies PayPal that the issuer declined the card.
PayPal checks to see if the card on file is eligible for real-time account updater.
PayPal sends a request to Mastercard to check whether the card's information is current.
Mastercard confirms that the card has changed, and sends the updated card information.
PayPal resubmits the payment on the merchant's behalf using the updated card information.
PayPal returns the updated card information to the merchant. If the card on file was a vaulted token, PayPal updates the card on file in the PayPal Complete Payments Platform vault.
When real-time account updater is enabled, PayPal flags the card for Visa to verify and update card information before the issuer processes the payment.
The buyer makes a purchase using a saved card on file, or the merchant uses the card for a recurring payment.
PayPal processes the payment as an advanced credit or debit card transaction.
PayPal checks if the card is eligible for real-time account updater.
PayPal flags the payment so Visa checks for card updates.
If the card has expired, been cancelled, or is otherwise unavailable, and an update is available, Visa submits the payment to the issuer using the updated card information.
After the issuer approves the payment, Visa returns the updated card information to PayPal.
PayPal returns the updated card information to the merchant. If the card was a vaulted token, PayPal updates the card in the vault.
If no update is available, Visa submits the payment using the original card information. The issuer approves or declines the payment.
Use sandbox trigger values to simulate real-time account updater scenarios. Pass these values in the card.name field when creating an order with POST /v2/checkout/orders.
Trigger value, Scenario, Behavior
Trigger value
Scenario
Behavior
CCREJECT-RTAU-EU
Expired card replaced with updated card
Returns updated card expiration
CCREJECT-RTAU-PEU
Lost or stolen card replaced with new card
Returns updated card number and expiration
CCREJECT-RTAU-AC
Card closed
Returns CARD_CLOSED error and declines the transaction
CCREJECT-RTAU-NU
No update available or cardholder opted out
No updates returned; declines if card is expired
The payment token id values in the token scenarios below are placeholders. Generate and use your own payment tokens.
This section shows how real-time account updater responds to 3 different card changes.
A token for an expired card is used for payment. The response returns the updated expiration date for the same card.
If you call GET /v3/vault/payment-tokens/{id} using the token before you submit the order using POST /v2/checkout/orders, the POST response includes the updated values that PayPal used to complete the payment. Compare the expiry returned by the GET call to the expiry returned by the POST call.